<?php
/* --------------------------------------------------------------
 MyModuleServiceProvider.php 2020-11-26
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace GXModules\Vendor\MyModule;

use Gambio\Admin\Layout\Renderer\GambioAdminLoader;
use Gambio\Core\Application\Modules\App\DependencyInjection\AbstractModuleBootableServiceProvider;
use Gambio\Core\Application\ValueObjects\Url;

class MyModuleServiceProvider extends AbstractModuleBootableServiceProvider
{
    public function provides(): array
    {
        return [
            MyLayoutAssetsLoader::class,
        ];
    }
    
    
    public function boot(): void
    {
        $this->application->inflect(GambioAdminLoader::class)->invokeMethod('addLoader', [MyLayoutAssetsLoader::class]);
    }
    
    
    public function register(): void
    {
        $this->application->registerShared(MyLayoutAssetsLoader::class)->addArgument(Url::class);
    }
}